/*
 * MoonPhaseCanvas.java
 * $Id: MoonPhaseCanvas.java,v 1.2 2003/06/29 13:53:48 take Exp $
 * 
 * Copyright Studio High-Score All Rights Reserved.
 *
 */
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;
import java.util.Random;

/**
 * MoonPhaseCanvas
 * CLoX
 *
 * @author TAKEchi Masashi
 * @version
 */
public final class MoonPhaseCanvas extends Canvas
    implements Runnable,CommandListener {

    /*
    int year;
    int month;
    int day;
    long UT;
    */

    private Random rand = new Random();
    Command aboutCommand;
    
    //_uobt@O
    private Image imgOff;//ItC[W
    private Graphics graOff;//ItOtBNX
    
    private MIDlet midlet;
    private final int star = 50;
    private final int fillstep = 10;
    private final int fix = 100;
    private final int imageW = 100;
    private final int imageH = 100;
    private Image moonImage;
    
    private int dx;
    private int dy;
    
    // Constructor
    public MoonPhaseCanvas(MIDlet midlet) {
        this.midlet = midlet;
        aboutCommand = new Command("ABOUT", Command.SCREEN, 2);
        
        addCommand(aboutCommand);
        setCommandListener(this);
        
        dx = (getWidth() - imageW) / 2;
        dy = (getHeight() - imageH) / 2;
        
        // double buffering
        imgOff = Image.createImage(getWidth(), getHeight());
        graOff = imgOff.getGraphics();
        
        try {
            moonImage = Image.createImage("/moon.png");
        }
        catch (Exception e) {
        }

        /*
        TimeZone tz = TimeZone.getTimeZone("GMT");
        Calendar calendar = Calendar.getInstance(tz);
        
        year = calendar.get(Calendar.YEAR);
        month = calendar.get(Calendar.MONTH);
        day = calendar.get(Calendar.DATE);
        
        UT = calendar.get(Calendar.HOUR_OF_DAY) * fix
            + calendar.get(Calendar.MINUTE) * fix / 60
            + calendar.get(Calendar.SECOND) * fix / 3600;
        */


    }
    
    // C[v
    public void run() {
        while (true) {
            repaint();
            try {
                Thread.sleep(1000);
            } catch (Exception e) {
            }
        }
    }
    
    // draw
    public void paint(Graphics g) {
        // check off image create
        if(graOff == null) {
            return;
        }
        // draw
        graOff.setColor(0);
        graOff.fillRect(0, 0, getWidth(), getHeight());

        /*
        graOff.setColor(0xffffff); // white
        graOff.fillArc(0 + dx, 0 + dy, imageW, imageH, 0, 360);
        */
        graOff.drawImage(moonImage
                         , dx
                         , dy
                         , graOff.LEFT|graOff.TOP);

        int moonAge = calcMoonAgeInt();
        //moonAge = 2500; // for debug
        graOff.setColor(0x000000); // black
        if(moonAge < 750) {
            leftShadow(); // fill half
            //leftShadow(2500, 5000); 
            rightShadow(moonAge * fix / 30);
        }
        else if(moonAge < 1500) {
            leftShadow(moonAge * fix / 30, 5000);
        }
        else if(moonAge < 2250) {
            rightShadow(5000, moonAge * fix / 30);
        }
        else {
            rightShadow();
            //rightShadow(0, 2500);
            leftShadow(moonAge * fix / 30);
        }
        int x, y, c;
        for(int i = star; i >= 0; i--) {
            c = (rand.nextInt() >>> 1) % 0x100;
            graOff.setColor((c<<16) + (c<<8) + c);
            x = (rand.nextInt() >>> 1) % getWidth();
            y = (rand.nextInt() >>> 1) % getHeight();
            graOff.drawLine(x, y, x, y);
        }
        
        g.drawImage(imgOff, 0, 0, g.LEFT | g.TOP);
    }
    
    public void leftShadow() {
        graOff.fillArc(dx, dy, imageW, imageH, 90, 180);
    }
    public void rightShadow() {
        graOff.fillArc(dx - 1, dy, imageW, imageH, 270, 180);
    }
    public void leftShadow(int start) {
        int t;
        int w;
        int elipseW;
        t = start * 2 * pi / fix / fix;
        w = cos[t];
        if(w < 0) {
            w = -w;
        }
        elipseW = imageW * w / fix;
        graOff.fillArc(dx + imageW / 2 - elipseW / 2, dy,
                       elipseW, imageH
                       , 90, 180);
    }
    public void leftShadow(int start, int end) {
        int t;
        int w;
        int elipseW;
        for(int i = start; i <= end; i+=fillstep) {
            t = i * 2 * pi / fix / fix;
            w = cos[t];
            if(w < 0) {
                w = -w;
            }
            elipseW = imageW * w / fix;
            graOff.drawArc(dx + imageW / 2 - elipseW / 2, dy,
                           elipseW, imageH
                           , 90, 180);
        }
    }
    public void rightShadow(int start) {
        int t;
        int w;
        int elipseW;
        t = start * 2 * pi / fix / fix;
        w = cos[t];
        if(w < 0) {
            w = -w;
        }
        elipseW = imageW * w / fix;
        graOff.fillArc(dx + imageW / 2 - elipseW / 2 -1, dy,
                       elipseW, imageH
                       , 270, 180);
    }
    public void rightShadow(int start, int end) {
        int t;
        int w;
        int elipseW;
        for(int i = end; i >= start; i-=fillstep) {
            t = i * 2 * pi / fix / fix;
            w = cos[t];
            if(w < 0) {
                w = -w;
            }
            elipseW = imageW * w / fix;
            graOff.drawArc(dx + imageW / 2 - elipseW / 2 - 1, dy,
                           elipseW, imageH
                           , 270, 180);
        }
    }
    private int calcMoonAgeInt() {
        /**/
        TimeZone tz = TimeZone.getTimeZone("GMT");
        Calendar calendar = Calendar.getInstance(tz);
        
        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH);
        int day = calendar.get(Calendar.DATE);
        
        long UT = calendar.get(Calendar.HOUR_OF_DAY) * fix
            + calendar.get(Calendar.MINUTE) * fix / 60
            + calendar.get(Calendar.SECOND) * fix / 3600;
        /**/
        int[] monD = new int[] {0, 2, 0, 2, 2, 4, 5, 6, 7, 8, 9, 10};
        int[] yHosei = new int[] {2044, 2025, 2006, 1987, 1968, 1949, 1930, 1911, 1892};
        
        for(int i=0; i < yHosei.length; i++) {
            if(year > yHosei[i]) {
                year -= yHosei[i];
                break;
            }
        }
        
        int moonAge = (year * 11 + monD[(int)month] + day) * fix 
            + (int)(UT / 24);
        moonAge %= 3000;

        return moonAge;
    }
    
    //R}hCxg
    public synchronized void commandAction(Command c, Displayable s) {
        if(c == aboutCommand) {
            Alert alert = new Alert("MoonPhase"
                                    , "TAKEchi Masashi (take@TAKEchon.NET)\nhttp://www.TAKEchon.NET/\n$Revision: 1.2 $\n$Date: 2003/06/29 13:53:48 $"
                                    , null, AlertType.INFO);
            alert.setTimeout(Alert.FOREVER);
            (Display.getDisplay(midlet)).setCurrent(alert);
        }
    }
    /*
    // key press events
    protected synchronized void keyPressed(int keyCode) {
        // game actions
        int action = getGameAction(keyCode);
        //clearCursor();
        if(action == UP) {
            day--;
        }
        else if (action == DOWN) {
            day++;
        }
    }
    */
    private final int[] cos = {
        100, 99, 99, 99, 99, 99, 99, 99, 99, 99, 
        99, 99, 99, 99, 99, 98, 98, 98, 98, 98, 
        98, 97, 97, 97, 97, 96, 96, 96, 96, 95, 
        95, 95, 94, 94, 94, 93, 93, 93, 92, 92, 
        92, 91, 91, 90, 90, 90, 89, 89, 88, 88, 
        87, 87, 86, 86, 85, 85, 84, 84, 83, 83, 
        82, 81, 81, 80, 80, 79, 78, 78, 77, 77, 
        76, 75, 75, 74, 73, 73, 72, 71, 71, 70, 
        69, 68, 68, 67, 66, 65, 65, 64, 63, 62, 
        62, 61, 60, 59, 58, 58, 57, 56, 55, 54, 
        54, 53, 52, 51, 50, 49, 48, 48, 47, 46, 
        45, 44, 43, 42, 41, 40, 39, 39, 38, 37, 
        36, 35, 34, 33, 32, 31, 30, 29, 28, 27, 
        26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 
        16, 16, 15, 14, 13, 12, 11, 10, 9, 8, 
        7, 6, 5, 4, 3, 2, 1, 0, 0, -1, 
        -2, -3, -4, -5, -6, -7, -8, -9, -10, -11, 
        -12, -13, -14, -15, -16, -17, -18, -19, -20, -21, 
        -22, -23, -24, -25, -26, -27, -28, -29, -30, -31, 
        -32, -33, -34, -35, -36, -37, -37, -38, -39, -40, 
        -41, -42, -43, -44, -45, -46, -46, -47, -48, -49, 
        -50, -51, -52, -53, -53, -54, -55, -56, -57, -58, 
        -58, -59, -60, -61, -62, -62, -63, -64, -65, -65, 
        -66, -67, -68, -68, -69, -70, -70, -71, -72, -73, 
        -73, -74, -75, -75, -76, -77, -77, -78, -78, -79, 
        -80, -80, -81, -81, -82, -83, -83, -84, -84, -85, 
        -85, -86, -86, -87, -87, -88, -88, -89, -89, -89, 
        -90, -90, -91, -91, -92, -92, -92, -93, -93, -93, 
        -94, -94, -94, -95, -95, -95, -96, -96, -96, -96, 
        -97, -97, -97, -97, -97, -98, -98, -98, -98, -98, 
        -98, -99, -99, -99, -99, -99, -99, -99, -99, -99, 
        -99, -99, -99, -99, -99, -99, -99, -99, -99, -99, 
        -99, -99, -99, -99, -99, -99, -99, -99, -99, -98, 
        -98, -98, -98, -98, -98, -97, -97, -97, -97, -96, 
        -96, -96, -96, -95, -95, -95, -94, -94, -94, -93, 
        -93, -93, -92, -92, -92, -91, -91, -90, -90, -90, 
        -89, -89, -88, -88, -87, -87, -86, -86, -85, -85, 
        -84, -84, -83, -83, -82, -82, -81, -80, -80, -79, 
        -79, -78, -77, -77, -76, -75, -75, -74, -73, -73, 
        -72, -71, -71, -70, -69, -69, -68, -67, -66, -66, 
        -65, -64, -63, -63, -62, -61, -60, -59, -59, -58, 
        -57, -56, -55, -55, -54, -53, -52, -51, -50, -49, 
        -49, -48, -47, -46, -45, -44, -43, -42, -41, -40, 
        -40, -39, -38, -37, -36, -35, -34, -33, -32, -31, 
        -30, -29, -28, -27, -26, -25, -24, -24, -23, -22, 
        -21, -20, -19, -18, -17, -16, -15, -14, -13, -12, 
        -11, -10, -9, -8, -7, -6, -5, -4, -3, -2, 
        -1, 0, 0, 1, 2, 3, 4, 5, 6, 7, 
        8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 
        18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 
        28, 29, 30, 31, 32, 33, 34, 35, 35, 36, 
        37, 38, 39, 40, 41, 42, 43, 44, 45, 45, 
        46, 47, 48, 49, 50, 51, 52, 52, 53, 54, 
        55, 56, 57, 57, 58, 59, 60, 61, 61, 62, 
        63, 64, 65, 65, 66, 67, 67, 68, 69, 70, 
        70, 71, 72, 72, 73, 74, 74, 75, 76, 76, 
        77, 78, 78, 79, 80, 80, 81, 81, 82, 82, 
        83, 84, 84, 85, 85, 86, 86, 87, 87, 88, 
        88, 89, 89, 89, 90, 90, 91, 91, 91, 92, 
        92, 93, 93, 93, 94, 94, 94, 95, 95, 95, 
        96, 96, 96, 96, 97, 97, 97, 97, 97, 98, 
        98, 98, 98, 98, 98, 99, 99, 99, 99, 99, 
        99, 99, 99, 99, 99, 99, 99, 99, 99, };
    private final int pi = 314;
}
